import {ApplicationCommandType, ChatInputCommandInteraction } from "discord.js";

import Command, { ApplicationIntegrationType, InteractionContextTypes } from "../command";

export default class Listen extends Command implements Command {
  // This command exists because Discord bots don't receive direct messages
  // unless they explicitly open a DM channel with the user
  name = "listen";
  description = "Makes the bot listen on your direct messages";
  type = ApplicationCommandType.ChatInput;

  options = [];
  integration_types = [
    ApplicationIntegrationType.Guild_Install,
    ApplicationIntegrationType.User_Install
  ];
  contexts = [InteractionContextTypes.BotDM];

  async execute(interaction: ChatInputCommandInteraction) {
    await interaction.user.createDM();
    await interaction.reply({
      content: "I'm now listening to your direct messages",
      ephemeral: true,
    });
  }
}
